#!perl

package UUID;

use strict;
use vars qw( @ISA @EXPORT );
use Fcntl;

require Exporter;

@ISA = qw(Exporter);
@EXPORT = qw (generate_uuid);

sub generate_uuid
{
	my @buf;
	my $i;

	## Get random bytes
	## rand() on Linux should use /dev/random and be reasonably good.  
	## YMMV on other platforms.
	for($i=0; $i<16; $i++) {
		$buf[$i] = rand(255);
	}

	## This is the only PITA left.  I haven't bothered b/c I'm too lazy to 
	## unravel the bitops required to clean it up.
	my $clock_seq = ((($buf[8] << 8) | $buf[9]) & 0x3FFF) | 0x8000;

	return sprintf("%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x",
		(($buf[0] << 24) | ($buf[1] << 16) | ($buf[2] << 8) | $buf[3]),
		(($buf[4] << 8) | $buf[5]),
		((($buf[6] << 8) | $buf[7] & 0x0FFF) | 0x4000),
		$clock_seq >> 8,
		$clock_seq & 0xFF,
		$buf[10],
		$buf[11],
		$buf[12],
		$buf[13],
		$buf[14],
		$buf[15]);
}
