#!/usr/bin/perl -w

use XML::Simple;
use LWP::Simple;

my $filename;
my $total = 0;
while($filename = <>) {
	chomp $filename;
	print "checking $filename\n";
	$total += fetch_price($filename) || 0;
}

print "Total value: $total\n";

sub fetch_price 
{
	my $filename = shift;
	## THis should re-import everything properly.
	my $ref = XMLin($filename, forcearray => [ "artist" ]);
	if(defined($ref->{barcode}) && ($ref->{barcode}->{type} eq 'UPC' || $ref->{barcode}->{type} eq 'UPA')) {
	#http://chapters.indigo.ca/music/details/Default.asp?UPC=724349791824	
		$content = get("http://chapters.indigo.ca/music/details/Default.asp?UPC=$ref->{barcode}->{content}");
		if(defined($content)) {
			my ($price) = $content =~ m!Our Price:\s+</b>\s+\$([\d\.]+)!;
			if($price) {
				print "$ref->{title}: $price\n";
				return $price;
			} else {
				print "No price found\n";
			}
		} else {
			print "No web info\n";
		}
	} else {
		print "No barcode\n";
	}
	return undef;
}
